Subject: Re: [PATCH v3 -next] vdpa: mlx5: change Kconfig depends to fix build errors

From: "Michael S. Tsirkin" <[email-masked]>
Date: Fri, 25 Sep 2020 06:19:30 -0400

On Fri, Sep 25, 2020 at 10:20:05AM +0300, Leon Romanovsky wrote:
> On Thu, Sep 24, 2020 at 12:02:43PM -0400, Michael S. Tsirkin wrote:
> > On Thu, Sep 24, 2020 at 08:47:05AM -0700, Randy Dunlap wrote:
> > > On 9/24/20 3:24 AM, Eli Cohen wrote:
> > > > On Thu, Sep 24, 2020 at 05:30:55AM -0400, Michael S. Tsirkin wrote:
> > > >>>> --- linux-next-20200917.orig/drivers/vdpa/Kconfig
> > > >>>> +++ linux-next-20200917/drivers/vdpa/Kconfig
> > > >>>> @@ -31,7 +31,7 @@ config IFCVF
> > > >>>>
> > > >>>>  config MLX5_VDPA
> > > >>>>  	bool "MLX5 VDPA support library for ConnectX devices"
> > > >>>> -	depends on MLX5_CORE
> > > >>>> +	depends on VHOST_IOTLB && MLX5_CORE
> > > >>>>  	default n
> > > >>>
> > > >>> While we are here, can anyone who apply this patch delete the "default n" line?
> > > >>> It is by default "n".
> > > >
> > > > I can do that
> > > >
> > > >>>
> > > >>> Thanks
> > > >>
> > > >> Hmm other drivers select VHOST_IOTLB, why not do the same?
> > >
> > > v1 used select, but Saeed requested use of depends instead because
> > > select can cause problems.
> > >
> > > > I can't see another driver doing that. Perhaps I can set dependency on
> > > > VHOST which by itself depends on VHOST_IOTLB?
> > > >>
> > > >>
> > > >>>>  	help
> > > >>>>  	  Support library for Mellanox VDPA drivers. Provides code that is
> > > >>>>
> > > >>
> > >
> >
> > Saeed what kind of problems? It's used with select in other places,
> > isn't it?
> 
> IMHO, "depends" is much more explicit than "select".
> 
> Thanks

This is now how VHOST_IOTLB has been designed though.
If you want to change VHOST_IOTLB to depends I think
we should do it consistently all over.

config VHOST_IOTLB
        tristate
        help
          Generic IOTLB implementation for vhost and vringh.
          This option is selected by any driver which needs to support
          an IOMMU in software.

> > > --
> > > ~Randy